/**
 * ...
 * @author Robert Lombardo, Wakefield Studios ( rob@wakefield-studios.com )
 */
const TreeNode = require( '../TreeNode' );
const BattleCalc = require( '../../BattleCalc' );
const UseAbility = require( '../UseAbility' );

const Q_which_jump_ability = function( actor, battleState ) {
	const node = new TreeNode( actor, battleState );

	// branch indexes
	node.MOVE = 0;
	node.JUMP = 1;
	
	node.branches[ node.MOVE ] = new UseAbility( actor, 'move' );
		
	// only one branch needed, since no hero has both Conjuration and Movement trees
	if( BattleCalc.getEquippedAbility(actor,'leap') ) {
		node.branches[ node.JUMP ] = new UseAbility( actor, 'leap' );
	} else if( BattleCalc.getEquippedAbility(actor,'teleport') ) {
		node.branches[ node.JUMP ] = new UseAbility( actor, 'teleport' );
	} else {
		node.branches[ node.JUMP ] = node.branches[ node.MOVE ];
	}								
	
	node.query = function( input ) { 
		if( BattleCalc.boardDistance( this.actor, input ) > 1 ) {
			return this.branches[this.JUMP].query( input );
		} else {
			return this.branches[this.MOVE].query( input );
		}		
	}

	return node;	
}
module.exports = Q_which_jump_ability
