/**
 * ...
 * @author Robert Lombardo, Wakefield Studios ( rob@wakefield-studios.com )
 */		
const YesNoNode = require( '../YesNoNode' );
const BattleCalc = require( '../../BattleCalc' );
const UseAbility = require( '../UseAbility' );

const Q_bleeding = function( actor, battleState, buffNode ) {
	const node = new YesNoNode( actor, battleState );

	if( BattleCalc.getEquippedAbility(actor,'healing_prayer') ) {
		node.branches[ node.NO ] = new UseAbility( actor, 'healing_prayer' );
	} else {
		node.branches[ node.NO ] = buffNode;
	}
	
	if( BattleCalc.getEquippedAbility(actor,'suture') ) {
		node.branches[ node.YES ] = new UseAbility( actor, 'suture' );
	} else {
		node.branches[ node.YES ] = node.branches[ node.NO ];
	}			
	
	node.yesNoEvalFunction = function( target ) {
		return BattleCalc.getCondition( target, 'bleeding' );
	}		
	
	return node;
}
module.exports = Q_bleeding
