const heroBase = require('../models/game_state/heroes');

const getAbilityLevel = function({
  ability_handle,
  tree_handle,
  unit_build,
}) {
  if (!ability_handle) {
    throw new Error('[getAbilityLevel] no ability_handle');
  }
  if (!unit_build) {
    throw new Error('[getAbilityLevel] no unit_build');
  }

  if (!tree_handle) {
    tree_handle = heroBase[unit_build.hero_handle]
      .getAbilityTrees()
      .find(tree => Object.keys(tree.abilities).includes(ability_handle))
      .handle;
    if (!tree_handle) {
      throw new Error('no tree_handle');
    }
  }

  const upgrades_by_tree = (unit_build.ability_upgrades || {})[tree_handle];
  return upgrades_by_tree
    ? upgrades_by_tree[ability_handle] || 0
    : 0;
};
module.exports = getAbilityLevel;
