const CHANCE_TO_SPAWN = 1 / 4;

const PortalFactory = (tiles) => {
  if (Math.random() < CHANCE_TO_SPAWN) {
    const unoccupied_tiles = [];
    for (const tile of tiles) {
      if (!tile.occupied) {
        unoccupied_tiles.push(tile);
      }
    }
    const portal_tile = unoccupied_tiles[
      Math.floor(Math.random() * unoccupied_tiles.length)
    ];
    portal_tile.occupied = true;

    return {
      portal: true,
      x: portal_tile.x,
      y: portal_tile.y,
    };
  }
};
module.exports = PortalFactory;
