const slime = (level) => {
  const AI_PRIORITIES = ['dps_close', 'tank', 'interference', 'support', 'dps_ranged'];
  const bags = [];

  return {
    handle: 'slime',
    level,
    getAbilityTrees: ((bound_level) => ([{
      handle: 'slime_abilities',
      abilities: {
        move: { handle: 'move', level: 1 },
        melee_attack: { handle: 'melee_attack', level: 1 },
        blurred_form: { handle: 'blurred_form', level: Math.min(10,Math.round(1+bound_level/2)) },
        fumigate: { handle: 'fumigate', level: Math.min(10,Math.round(1+bound_level/2)) },
      },
    }])).bind(null, level),
    getBaseAttributes: ((bound_level) => ({
      learning: Math.round(0.1 + bound_level*0.1 + Math.random()*3),
      perception: Math.round(0.1 + bound_level*0.1 + Math.random()*3),
      mana: Math.round(0.4 + bound_level*0.4 + Math.random()*3),
      toughness: Math.round(2.1 + bound_level*1.5 + Math.random()*3),
      strength: Math.round(1.2 + bound_level*0.8 + Math.random()*3),
      willpower: Math.round(1.7 + bound_level*1.1 + Math.random()*3),
      dexterity: Math.round(0.1 + bound_level*0.1 + Math.random()*3),
    })).bind(null, level),
    getDefaultAIConfig: () => AI_PRIORITIES,
    xpValue: level * 300,
    bags,
    build: {
      ai: {
        priorities: AI_PRIORITIES,
        settings: {
          chanceToSkipRoles: true,
          autoMove: true,
          waitForAPMP: false,
        },
      },
      ai_unit: true,
      beast: false,
      equipment_assignment: {},
      equipped_abilities: ['move', 'melee_attack', 'blurred_form', 'fumigate'],
      handle: 'slime',
      humanoid: false,
      level,
      slime: true,
      team: 'black',
      undead: false,
      unit: true,
    },
  };
};
module.exports = slime;
