var ItemGenerator = require( '../../../game_items/ItemGenerator.js' );
var LightHelmet = require( '../../../game_items/equipment/helmet/LightHelmet.js' );
var LightTorsoe = require( '../../../game_items/equipment/torsoe/LightTorsoe.js' );
var LightBoots = require( '../../../game_items/equipment/boots/LightBoots.js' );
var Staff = require( '../../../game_items/equipment/weapon/Staff.js' );
var Book = require( '../../../game_items/equipment/off_hand/Book.js' );

module.exports = function() {    
    return {
        handle: "invoker",
        unit: true,
        tutorialHero: true,
        attributes: {
            base: {
                learning:   50,
                perception: 50,
                mana:       50,
                toughness:  50,
                strength:   50,
                willpower:  50,
                dexterity:  50,
                regeneration: 0,
                speed: 0,
                magicalGravity: 0,
                meleeDamage: 0,
                armorClass: 0,
                dodgeChance: 0,
                physicalResil: 0,
                mentalResil: 0
            },
            fromUpgrades: {
                learning:   0,
                perception: 0,
                mana:       0,
                toughness:  0,
                strength:   0,
                willpower:  0,
                dexterity:  0
            }
        },
        abilityTrees: [{    
            handle: 'skeleton_abilities',             
            abilities: {
                move:                   {handle: 'move',                level:1},
                melee_attack:           {handle: 'melee_attack',        level:1},
                burning_hands:          {handle: 'burning_hands',       level:10},                 
                fumigate:               {handle: 'fumigate',            level:10},                
                lightning:              {handle: 'lightning',           level:10},               
                molotov_cocktail:       {handle: 'molotov_cocktail',    level:10},                
                summon_option:          {handle: 'summon_option',       level:10},                
                healing_prayer:         {handle: 'healing_prayer',      level:10},                
                mystic_focus:           {handle: 'mystic_focus',        level:10},                
                bless:                  {handle: 'bless',               level:10},                
                sanctuary:              {handle: 'sanctuary',           level:10},                
                holy_force:             {handle: 'holy_force',           level:10}
            }
        }],
        equipped_abilities: ['move','melee_attack','burning_hands','fumigate','lightning','void_spike','summon_option','healing_prayer','mystic_focus','bless','sanctuary','holy_force'],
        ai: {
            priorities: ["dps_ranged",  "support", "dps_close", "interference", "tank" ],
            settings: {
                chanceToSkipRoles: true,
                autoMove: true,
                waitForAPMP: false
            }
        },
        equipment: {
            helmet: ItemGenerator.getRandomItem( LightHelmet, 1.0, 1.0 ),
            torsoe: ItemGenerator.getRandomItem( LightTorsoe, 1.0, 1.0 ),
            boots: ItemGenerator.getRandomItem( LightBoots, 1.0, 1.0 ),
            weapon: ItemGenerator.getRandomItem( Staff, 1.0, 1.0 ),
            off_hand: ItemGenerator.getRandomItem( Book, 1.0, 1.0 )
        }
    };
};
